import json
import sys


#----------------------------------------------
# classe contenant les parametres
#----------------------------------------------
class Tparam:
    def __init__(self):
        """Constructeur de Tparam"""
        self.fichiersortie = ""
        self.npas   = -1
        self.t0     = -1
        self.angles = []
    
    #----------------------------------------------
    # lecture des parametres
    #----------------------------------------------
    def read(self, nomfichier):
        """lecture du fichier de parametres : nomfichier"""
        print("lecture du fichier ", nomfichier)
        with open(nomfichier) as json_data_file:
            datain = json.load(json_data_file)
        self.fichiersortie = datain["fichiersortie"]
        self.npas          = datain["npas"]
        self.t0            = datain["t0"]
        self.angles        = datain["angles"]
    
    #----------------------------------------------
    # ecriture des parametres
    #----------------------------------------------
    def write(self, nomfichier):
        """ecriture du fichier de parametres : nomfichier"""
        print("ecriture du fichier ", nomfichier)
        dataout = { 
            "fichiersortie" : self.fichiersortie,
            "npas"          : self.npas,
            "t0"            : self.t0,
            "angles"        : self.angles,
        }    
        with open(nomfichier, 'w') as outfile:
            json.dump(dataout, outfile)

#----------------------------------------------
# programme principal
# usage :  exjson fichierentree.json
#----------------------------------------------
if __name__ == '__main__':
    myparam = Tparam() 
    fichierentree = sys.argv[1]
    myparam.read(fichierentree)
    myparam.write(myparam.fichiersortie)
